import * as i1 from '@angular-three/core';
import { NgtAnimationParticipant } from '@angular-three/core';
import * as i0 from '@angular/core';
import { EventEmitter, Directive, SkipSelf, Output } from '@angular/core';
import { takeUntil } from 'rxjs/operators';

class NgtControls extends NgtAnimationParticipant {
    constructor(ngZone, canvasStore, animationStore, destroyed) {
        super(animationStore, ngZone);
        this.canvasStore = canvasStore;
        this.destroyed = destroyed;
        this.ready = new EventEmitter();
    }
    ngOnInit() {
        this.ngZone.runOutsideAngular(() => {
            this.canvasStore.selectors.internal$
                .pipe(takeUntil(this.destroyed))
                .subscribe(({ active }) => {
                this.ngZone.runOutsideAngular(() => {
                    const { camera, renderer, scene } = this.canvasStore.getImperativeState();
                    if (active && camera && renderer && scene) {
                        this._controls = this.initControls(camera, renderer, scene);
                        if (this.controls) {
                            this.ready.emit(this.controls);
                            this.participate(this.controls);
                        }
                    }
                });
            });
        });
    }
    get controls() {
        return this._controls;
    }
    ngOnDestroy() {
        super.ngOnDestroy();
        this.ngZone.runOutsideAngular(() => {
            if (this.controls && this.controls.dispose) {
                this.controls.dispose();
            }
        });
    }
}
NgtControls.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtControls, deps: [{ token: i0.NgZone }, { token: i1.CanvasStore, skipSelf: true }, { token: i1.AnimationStore, skipSelf: true }, { token: i1.DestroyedService }], target: i0.ɵɵFactoryTarget.Directive });
NgtControls.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.0.2", type: NgtControls, outputs: { ready: "ready" }, usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: NgtControls, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i0.NgZone }, { type: i1.CanvasStore, decorators: [{
                    type: SkipSelf
                }] }, { type: i1.AnimationStore, decorators: [{
                    type: SkipSelf
                }] }, { type: i1.DestroyedService }]; }, propDecorators: { ready: [{
                type: Output
            }] } });

/**
 * Generated bundle index. Do not edit.
 */

export { NgtControls };
