import { AnimationStore, CanvasStore, DestroyedService, NgtAnimationParticipant, NgtCamera } from '@angular-three/core';
import { EventEmitter, NgZone, OnDestroy, OnInit } from '@angular/core';
import * as THREE from 'three';
import * as i0 from "@angular/core";
export declare abstract class NgtControls<TControls = unknown> extends NgtAnimationParticipant<TControls> implements OnInit, OnDestroy {
    protected canvasStore: CanvasStore;
    protected destroyed: DestroyedService;
    ready: EventEmitter<TControls>;
    constructor(ngZone: NgZone, canvasStore: CanvasStore, animationStore: AnimationStore, destroyed: DestroyedService);
    private _controls?;
    ngOnInit(): void;
    get controls(): TControls | undefined;
    abstract initControls(camera: NgtCamera, renderer: THREE.WebGLRenderer, scene: THREE.Scene): TControls;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtControls<any>, [null, { skipSelf: true; }, { skipSelf: true; }, null]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtControls<any>, never, never, {}, { "ready": "ready"; }, never>;
}
